﻿Public Partial Class Test
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub cmdExecute_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdExecute.Click
        Dim report As Byte() = Nothing
        ' Create an instance of the Reporting Services
        ' Web Reference. 
        Dim rs As RptExecSvc.ReportExecutionService _
                                = New RptExecSvc.ReportExecutionService
        ' Create the credentials that will be used when accessing
        ' Reporting Services. This must be a logon that has rights
        ' to the Axelburg Invoice-Batch Number report. 
        ' *** Replace "LoginName", "Password", and "Domain" with
        '     the appropriate values. ***
        rs.Credentials = New  _
              System.Net.NetworkCredential("LoginName", _
              "Password", "Domain")
        rs.PreAuthenticate = True

        ' The Reporting Services virtual path to the report.
        Dim reportPath As String = _
        "/Galactic Delivery Services/Axelburg/Invoice-Batch Number Report"

        ' The rendering format for the report. 
        Dim format As String = "HTML4.0"

        ' The devInfo string tells the report viewer
        ' how to display with the report. 
        Dim devInfo As String = _
             "<DeviceInfo>" + _
             "<Toolbar>False</Toolbar>" + _
             "<Parameters>False</Parameters>" + _
             "<DocMap>True</DocMap>" + _
             "<Zoom>100</Zoom>" + _
             "</DeviceInfo>"

        ' Create an array of the values for the report parameters
        Dim parameters(1) As RptExecSvc.ParameterValue
        Dim paramValue As RptExecSvc.ParameterValue _
                                  = New RptExecSvc.ParameterValue
        paramValue.Name = "StartDate"
        paramValue.Value = calStartDate.SelectedDate
        parameters(0) = paramValue
        paramValue = New RptExecSvc.ParameterValue
        paramValue.Name = "EndDate"
        paramValue.Value = calEndDate.SelectedDate
        parameters(1) = paramValue

        ' Create variables for the remainder of the parameters
        Dim historyID As String = Nothing
        Dim credentials() As RptExecSvc.DataSourceCredentials = Nothing
        Dim showHideToggle As String = Nothing
        Dim encoding As String
        Dim mimeType As String
        Dim warnings() As RptExecSvc.Warning = Nothing
        Dim reportHistoryParameters() As  _
                             RptExecSvc.ParameterValue = Nothing
        Dim streamIDs() As String = Nothing

        Dim execInfo As New RptExecSvc.ExecutionInfo
        Dim execHeader As New RptExecSvc.ExecutionHeader
        rs.ExecutionHeaderValue = execHeader
        execInfo = rs.LoadReport(reportPath, historyID)
        rs.SetExecutionParameters(parameters, "en-us")

        Try
            ' Execute the report. 
            report = rs.Render(format, _
                       devInfo, "", mimeType, "", warnings, streamIDs)

            ' Flush any pending response. 
            Response.Clear()

            ' Set the HTTP headers for a PDF response. 
            HttpContext.Current.Response.ClearHeaders()
            HttpContext.Current.Response.ClearContent()
            HttpContext.Current.Response.ContentType = "text/html"
            ' filename is the default filename displayed
            ' if the user does a save as. 
            HttpContext.Current.Response.AppendHeader( _
                    "Content-Disposition", _
                    "filename=""Invoice-BatchNumber.HTM""")

            ' Send the byte array containing the report
            ' as a binary response. 
            HttpContext.Current.Response.BinaryWrite(report)
            HttpContext.Current.Response.End()
        Catch ex As Exception
            If ex.Message <> "Thread was being aborted." Then
                HttpContext.Current.Response.ClearHeaders()
                HttpContext.Current.Response.ClearContent()
                HttpContext.Current.Response.ContentType = "text/html"
                HttpContext.Current.Response.Write( _
                                "<HTML><BODY><H1>Error</H1><br><br>" & _
                                ex.Message & "</BODY></HTML>")
                HttpContext.Current.Response.End()
            End If
        End Try

    End Sub
End Class