Imports System.Web.Security
Imports System.Net
Imports System.Web

Namespace MSSQLRS.FormsSecurity

    Public Class UILogon
        Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub
        Protected WithEvents btnLogon As System.Web.UI.WebControls.Button
        Protected WithEvents txtUserName As System.Web.UI.WebControls.TextBox
        Protected WithEvents Label3 As System.Web.UI.WebControls.Label
        Protected WithEvents Label2 As System.Web.UI.WebControls.Label
        Protected WithEvents Label4 As System.Web.UI.WebControls.Label
        Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
        Protected WithEvents Label1 As System.Web.UI.WebControls.Label
        Protected WithEvents lblMessage As System.Web.UI.WebControls.Label

        'NOTE: The following placeholder declaration is required by the Web Form Designer.
        'Do not delete or move it.
        Private designerPlaceholderDeclaration As System.Object

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region
        ' The sample is based on Microsoft's Forms Authentication Sample for Reporting Services. 
        ' The original sample was written in C#. It has been translated it into Visual Basic 
        ' for consistency with the other examples in this book. Some revisions were also made 
        ' to better fit with the Galactic Delivery Services examples.

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'Put user code to initialize the page here
        End Sub

        Private Sub btnLogon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogon.Click
            Dim passwordVerified As Boolean = False
            Dim redirectUrl As String

            If MSSQLRS.FormsSecurity.CheckAuthentication.ValidateString(txtUserName.Text) And _
                MSSQLRS.FormsSecurity.CheckAuthentication.ValidateString(txtPassword.Text) Then

                Try
                    Dim server As ReportServerProxy = New ReportServerProxy

                    server.LogonUser(txtUserName.Text, txtPassword.Text, Nothing)

                    passwordVerified = True

                Catch ex As Exception
                    lblMessage.Text = "Logon failed"
                    Return
                End Try

                If passwordVerified = True Then
                    lblMessage.Text = "Logon successful: User is authenticated"
                    redirectUrl = Request.QueryString("ReturnUrl")
                    If Not redirectUrl Is Nothing Then
                        HttpContext.Current.Response.Redirect(redirectUrl, False)
                    Else
                        HttpContext.Current.Response.Redirect("./Folder.aspx", False)
                    End If
                Else
                    lblMessage.Text = "Invalid username or password"
                End If
            Else
                lblMessage.Text = "There is an illegal character in the username or password."
            End If

        End Sub
    End Class

    ' Because the UILogon uses the Web service to connect to the report server
    ' you need to extend the server proxy to support authentication ticket
    ' (cookie) management
    Public Class ReportServerProxy : Inherits RSWebService.ReportingService2005
        Protected Overrides Function GetWebRequest(ByVal uri As Uri) As WebRequest
            Dim temp As RSWebService.ReportingService2005
            Dim request As HttpWebRequest
            Dim cookieJar As CookieContainer = New CookieContainer
            Dim localAuthCookie As Cookie

            request = HttpWebRequest.Create(uri)
            ' Create a cookie jar to hold the request cookie
            request.CookieContainer = cookieJar
            localAuthCookie = AuthCookie
            ' if the client already has an auth cookie
            ' place it in the request's cookie container
            If Not AuthCookie Is Nothing Then
                request.CookieContainer.Add(localAuthCookie)
            End If
            request.Timeout = -1
            request.Headers.Add("Accept-Language", HttpContext.Current.Request.Headers("Accept-Language"))

            Return request
        End Function

        Protected Overrides Function GetWebResponse(ByVal request As WebRequest) As WebResponse
            Dim response As WebResponse = MyBase.GetWebResponse(request)
            Dim cookieName As String = response.Headers("RSAuthenticationHeader")
            Dim webResponse As HttpWebResponse
            Dim localAuthCookie As Cookie

            ' If the response contains an auth header store the cookie
            If Not cookieName Is Nothing Then
                Utilities.CustomAuthCookieName = cookieName
                webResponse = response
                localAuthCookie = webResponse.Cookies(cookieName)

                ' If the auth cookie is null, throw an exception
                If localAuthCookie Is Nothing Then
                    Throw New Exception("Authorization ticket not received by LogonUser")
                End If

                ' otherwise save it for this request
                AuthCookie = localAuthCookie

                ' and send it to the client
                Utilities.RelayCookieToClient(localAuthCookie)
            End If

            Return response
        End Function

        Private Property AuthCookie() As Cookie
            Get
                If m_Authcookie Is Nothing Then
                    m_Authcookie = Utilities.TranslateCookie(HttpContext.Current.Request.Cookies(Utilities.CustomAuthCookieName))
                End If
                Return m_Authcookie
            End Get
            Set(ByVal Value As Cookie)
                m_Authcookie = Value
            End Set
        End Property

        Private m_Authcookie As Cookie = Nothing

    End Class

    Public Class Utilities
        Shared Property CustomAuthCookieName() As String
            Get
                Return m_cookieName
            End Get
            Set(ByVal Value As String)
                m_cookieName = Value
            End Set
        End Property

        Private Shared m_cookieName As String
        Private Shared m_cookieNamelockRoot As Object = New Object

        Shared Function TranslateCookie(ByVal netCookie As Cookie) As HttpCookie
            Dim webCookie As HttpCookie

            If netCookie Is Nothing Then
                Return Nothing
            End If

            webCookie = New HttpCookie(netCookie.Name, netCookie.Value)

            ' Add domain only if it is dotted - IE doesn't send back the cookie 
            ' if we set the domain otherwise
            If netCookie.Domain.IndexOf(".") <> -1 Then
                webCookie.Domain = netCookie.Domain
            End If
            webCookie.Expires = netCookie.Expires
            webCookie.Path = netCookie.Path
            webCookie.Secure = netCookie.Secure

            Return webCookie

        End Function

        Shared Function TranslateCookie(ByVal webCookie As HttpCookie) As Cookie
            Dim netCookie As Cookie

            If webCookie Is Nothing Then
                Return Nothing
            End If

            netCookie = New Cookie(webCookie.Name, webCookie.Value)
            If webCookie.Domain Is Nothing Then
                netCookie.Domain = HttpContext.Current.Request.ServerVariables("SERVER_NAME")
            End If

            netCookie.Expires = webCookie.Expires
            netCookie.Path = webCookie.Path
            netCookie.Secure = webCookie.Secure

            Return netCookie

        End Function

        Shared Sub RelayCookieToClient(ByVal cookie As Cookie)
            ' add the cookie if not already in there
            If HttpContext.Current.Response.Cookies(cookie.Name) Is Nothing Then
                HttpContext.Current.Response.Cookies.Remove(cookie.Name)
            End If

            HttpContext.Current.Response.SetCookie(TranslateCookie(cookie))

        End Sub
    End Class

End Namespace
